#include "Benchmark.h"
#include <tagcoll/Exception.h>

#include <iostream>

using namespace std;
using namespace Tagcoll;

int main(int argc, const char* argv[])
{
	try {
		// We want predictable results
		srand(1);

		if (argc == 1)
			Benchmark::root()->run();
		else
		{
			for (int i = 1; i < argc; i++)
				if (argv[i][0] == '/')
					Benchmark::root()->run(argv[i]+1);
				else
					Benchmark::root()->run(argv[i]);
		}

		return 0;
	} catch (Exception& e) {
		cerr << e.type() << ": " << e.desc() << endl;
	} catch (exception& e) {
		cerr << e.what() << endl;
	}
	return 1;
}

/* vim:set ts=4 sw=4: */
