#include <tagcoll/TDBReadonlyDiskIndex.h>
#include <tagcoll/Serializer.h>
#include <tagcoll/TextFormat.h>

#include <stdarg.h>

using namespace std;
using namespace Tagcoll;

int main (int argc, char *argv[])
{
	try {
		// Install the handler for unexpected exceptions
		InstallUnexpected installUnexpected;
		TrivialConverter<string, string> conv;
		TDBReadonlyDiskIndex<string, string> coll(
				argv[1], argv[2],
				conv, conv, conv, conv);

		TextFormat<string, string> writer(conv, conv, stdout);
		coll.output(writer);

		return 0;
	} catch (Exception& e) {
		fprintf(stderr, "%s: %.*s\n", e.type(), PFSTR(e.desc()));
	}
}

// vim:set ts=4 sw=4:
